﻿namespace UltraGridBringRowIntoView
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        const string MasterTableName = "Master Table";
        const string ChildTableName = "Child Table";
        const string IdColumn = "Id";
        const string NameColumn = "Name";
        const string ParentIdColumn = "Parent Id";

        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.ultraGrid1.AfterRowExpanded += UltraGrid1_AfterRowExpanded;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Create some relational data set
            var dataSet = this.GetDataSet();

            // Bind the grid to the relational data set
            this.ultraGrid1.SetDataBinding(dataSet, dataSet.Tables[MasterTableName].TableName);
        }

        private void UltraGrid1_AfterRowExpanded(object sender, RowEventArgs e)
        {
            //  Force the grid to scroll the expanded row to the top of the RowScrollRegion
            this.ultraGrid1.ActiveRowScrollRegion.FirstRow = e.Row;
        }

        #region GetDataSet
        private DataSet GetDataSet()
        {
            var ds = new DataSet();
            var masterTable = ds.Tables.Add(MasterTableName);

            masterTable.Columns.Add(IdColumn, typeof(int));
            masterTable.Columns.Add(NameColumn);

            for(int row = 1; row <= 20; row++)
            {
                masterTable.Rows.Add(new object[] { row, "Parent " + row });

            }

            var childTable = ds.Tables.Add(ChildTableName);

            childTable.Columns.Add(IdColumn, typeof(int));
            childTable.Columns.Add(NameColumn);
            childTable.Columns.Add(ParentIdColumn, typeof(int));

            for(int row = 1; row <= 20; row++)
            {
                childTable.Rows.Add(new object[] { row, "Child " + row + "." + row, row });
            }
            ds.Relations.Add(masterTable.Columns[IdColumn], childTable.Columns[ParentIdColumn]);

            return ds;
        }
        #endregion GetDataSet
    }
}
